=== debian/changelog ===
slic3r-prusa (2.2.0+dfsg1-3) unstable; urgency=medium

  * [4bab085] Reduce debug info on armhf.
    Apparently 90MB is too much for armhf. (Closes: #961373)

 -- Chow Loong Jin <hyperair@debian.org>  Mon, 28 Sep 2020 01:13:24 +0800

slic3r-prusa (2.2.0+dfsg1-2) unstable; urgency=medium

  * [38942b0] Fix FTBFS on mips, and mipsel (oom), and i386 (float issues)
    Thanks to Adrian Bunk <bunk@debian.org> (Closes: #961107)

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 22 May 2020 12:40:15 +0800

slic3r-prusa (2.2.0+dfsg1-1) unstable; urgency=medium

  * [187c962] Drop upstreamed patches
  * [efbc72c] Update libwxgtk3.0-dev build-dep to libwxgtk3.0-gtk3-dev.
    Update SLIC3R_GTK cmake option to 3 as well. We no longer have a gtk2
    version of wxgtk around.
  * [4d21963] Build-dep on libopenvdb-dev
  * [4c977a3] Drop perl build-dep.
    We're no longer a perl program
  * [954c058] Build-dep on libcgal-dev
  * [6353674] Build-dep on libudev-dev
  * [f4377be] Exclude deps folder.
    Upstream seems to have bundled the world.
  * [12cf549] New upstream version 2.2.0+dfsg1

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 07 Apr 2020 23:08:57 +0800

slic3r-prusa (2.2.0+dfsg-1) UNRELEASED; urgency=medium

  * [922dd32] New upstream version 2.2.0+dfsg

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 26 Mar 2020 00:21:06 +0800

slic3r-prusa (2.1.1+dfsg-3) unstable; urgency=medium

  * [a3155f2] Build against gtk2 instead of gtk3

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 28 Jan 2020 10:53:39 +0800
